import * as Library from "./library/library";
import { Name as Person } from "./model/common/name";
import { Car, Color } from "./model/common/car";
import { Table } from "./model/generic/table";
import { Column, ColumnType } from "./model/generic/column";
import { Option } from "./model/generic/option";
import * as $ from "jquery";
//
// studentRoster
//
var studentRoster = [
    new Person({
        id: 1,
        first: 'Shawn',
        last: 'Lovelidge'
    }),
    new Person({
        id: 2,
        first: 'Lisa',
        last: 'Weaver'
    }),
    new Person({
        id: 3,
        first: 'David',
        last: 'McDavid'
    }),
    new Person({
        id: 4,
        first: 'Miriam',
        last: 'Porter'
    })
];
//
// carCollection
//
var carCollection = [
    new Car({
        id: 1,
        make: 'Toyota',
        model: '4 Runner',
        color: Color.White,
        year: 2018
    }),
    new Car({
        id: 2,
        make: 'Toyota',
        model: 'Corolla',
        color: Color.Red,
        year: 2017
    }),
    new Car({
        id: 3,
        make: 'Lexus',
        model: 'ES',
        color: Color.Blue,
        year: 2016
    }),
];
/**
 * onClick()
 * @param $event
 */
function onClick($event) {
    var column = $event.target.innerText;
    console.info("SortBy(): " + column);
    ascending = !ascending;
    if (document.getElementById("idc_car_container").style.display === 'block') {
        cars.Sortby(column, ascending);
    }
    else {
        students.Sortby(column, ascending);
    }
}
var ascending = true;
//
// Define Student Roster
//
var students = new Table(new Option({ sortBy: 'last', orderBy: 'id', containerId: 'idc_students' }), [
    new Column({ id: 0, field: 'id', label: 'Id', visible: true, type: ColumnType.Number, onClick: onClick }),
    new Column({ id: 1, field: 'first', label: 'First', visible: true, onClick: onClick }),
    new Column({ id: 2, field: 'last', label: 'Last', visible: true, onClick: onClick }),
    new Column({ id: 3, field: 'created', label: 'Date Created', visible: true, type: ColumnType.DateTime, onClick: onClick })
]);
//
// Define Cars
//
var cars = new Table(new Option({ sortBy: 'year', orderBy: 'id', containerId: 'idc_car_collection' }), [
    new Column({ id: 0, field: 'id', label: 'Id', visible: true, type: ColumnType.Number, onClick: onClick }),
    new Column({ id: 1, field: 'make', label: 'Make', visible: true, onClick: onClick }),
    new Column({ id: 2, field: 'model', label: 'Model', visible: true, onClick: onClick }),
    new Column({ id: 3, field: 'color', label: 'Color', visible: true, onClick: onClick }),
    new Column({ id: 4, field: 'year', label: 'Year', visible: true, onClick: onClick })
]);
//
// Document Ready
//
$(document).ready(function () {
    //
    // Debug Statement
    //
    console.log('TypeScript 2.0 Project');
    //
    // Handle Click Events
    //
    $(".btn-primary").on('click', function () {
        if (this.innerText === 'Car Collection') {
            document.getElementById("idc_car_container").style.display = "block";
            document.getElementById("idc_student_container").style.display = "none";
        }
        else if (this.innerText === 'Student Roster') {
            document.getElementById("idc_car_container").style.display = "none";
            document.getElementById("idc_student_container").style.display = "block";
        }
    });
    //
    // Render the Student Roster
    //
    if (Library.isDefined(students)) {
        students.items = studentRoster;
    }
    //
    // Render the Car Collection
    //
    if (Library.isDefined(carCollection)) {
        cars.items = carCollection;
    }
});
//# sourceMappingURL=/Users/admin/Desktop/git/sandbox/typescript/src/index.js.map